from typing import Literal, ClassVar

from .strand import Strand


class Orientation:
    Forward: ClassVar[Orientation]
    Dual: ClassVar[Orientation]
    Reverse: ClassVar[Orientation]

    def __init__(self, value: IntoOrientation) -> None: ...

    # def flip(self) -> Orientation: ...

    def flipped(self) -> Orientation: ...

    def symbol(self) -> str: ...

    def to_strand(self) -> Strand: ...

    def __repr__(self) -> str: ...

    def __str__(self) -> str: ...

    def __hash__(self) -> int: ...

    def __eq__(self, other: object) -> bool: ...

    def __ne__(self, other: object) -> bool: ...

    def __lt__(self, other: object) -> bool: ...

    def __le__(self, other: object) -> bool: ...

    def __gt__(self, other: object) -> bool: ...

    def __ge__(self, other: object) -> bool: ...


IntoOrientation = Orientation | Literal["+", "-", "=", 1, -1, 0]
