from typing import Literal, ClassVar

from .orientation import Orientation


class Strand:
    Forward: ClassVar[Strand]
    Reverse: ClassVar[Strand]

    def __init__(self, value: IntoStrand) -> None: ...

    def flipped(self) -> Strand: ...

    def symbol(self) -> str: ...

    def to_orientation(self) -> Orientation: ...

    def __repr__(self) -> str: ...

    def __str__(self) -> str: ...

    def __hash__(self) -> int: ...

    def __eq__(self, other: object) -> bool: ...

    def __ne__(self, other: object) -> bool: ...

    def __lt__(self, other: object) -> bool: ...

    def __le__(self, other: object) -> bool: ...

    def __gt__(self, other: object) -> bool: ...

    def __ge__(self, other: object) -> bool: ...


IntoStrand = Strand | Literal["+", "-", 1, -1]
